Subject: Re: Realtek 8139 problem on 486.

From: Nikolai Zhubr <[email-masked]>
Date: Mon, 31 May 2021 02:17:20 +0300

Hi all,

30.05.2021 23:54, Arnd Bergmann:
[...]
>> Unmodified kernel 2.6.2 works fine, unmodified kernel 2.6.3 shows
>> reproducable connectivity issues.
>>
>> The diff is not small, I'm not sure I can dig through.
>> Any hints/ideas greatly appreciated.
>
> This is apparently when NAPI was introduced into the driver.
>
> One thing I noticed here was the handling for shared IRQs changing in
> the process. Do you happen to have shared IRQs, and if so, can you

I think this IRQ is not shared:

# cat /proc/interrupts
            CPU0
   0:     322570          XT-PIC  timer
   1:          8          XT-PIC  i8042
   2:          0          XT-PIC  cascade
   9:        896          XT-PIC  eth0
  14:      18000          XT-PIC  ide0
NMI:          0
ERR:          0

# dmesg | grep -i irq
eth0: RealTek RTL8139 at 0xc4800000, 00:11:6b:32:85:74, IRQ 9
ide0 at 0x1f0-0x1f7,0x3f6 on irq 14
serio: i8042 AUX port at 0x60,0x64 irq 12
serio: i8042 KBD port at 0x60,0x64 irq 1

However indeed, it seems a problem was introduced with a rework of 
interrupt handling (rtl8139_interrupt) in 2.6.3, because I have already 
pushed all other differences from 2.6.3 to 2.6.2 and it still keeps 
working fine.
My resulting minimized diff is still ~300 lines, it is too big and 
complicated to be usefull to post here as is.

Thank you,

Regards,
Nikolai

> change it so this card has an IRQ that is not shared with any other
> device?
>
>          Arnd
>